/*****************************
* @File Name: DS1302.C
* @Author	: JZHG
* @Time     : 2012-11-05
* @Version  : V1.0
******************************/

#include "DS1302.h"

/***********************************************************
*	   һʱṹBCD ʱʼֵ
************************************************************/
					 // 	     ʱ	  		 	
TIME_TYPE CurrentTime={0x30, 0x13, 0x23, 0x12, 0x12, 0x02, 0x12 };  

/***********************************************************
* ƣDS1302_WriteByte
* ܣDS1302дһByteݺ
*           ڲ:dat     ڲ
***********************************************************/

static void DS1302_WriteByte( uchar dat )
{
	uchar i;

	for ( i=0; i<8; i++)
	{
		if ( dat&0x01 )
		{
			DS1302_IO_HIGH;
		}
		else DS1302_IO_LOW; 
		DS1302_SCLK_HIGH;
		DS1302_SCLK_LOW ;
		dat>>=1;
	}
}

/***********************************************************
* ƣDS1302_ReadByte
* ܣDS1302һByteݺ
*           ڲ:     ڲdat
***********************************************************/

static uchar DS1302_ReadByte( void )
{
	uchar i, dat;
	for ( i=0; i<8; i++ )
	{
		dat>>=1;
		if ( DS1302_IO_READ )
		{
			dat |= 0x80;	
		}
		else dat &=0x7f;
		DS1302_SCLK_HIGH;
		DS1302_SCLK_LOW ;
	}
	return dat;
} 

/***********************************************************
* ƣDS1302_WriteByteToAddr
* ܣDS1302ַָдһByte
*           ڲ:addr dat   ڲ
***********************************************************/

void DS1302_WriteByteToAddr( uchar addr, uchar dat )
{
	DS1302_RST_LOW;
	DS1302_SCLK_LOW;
	DS1302_RST_HIGH;
	DS1302_WriteByte(addr);
	DS1302_WriteByte(dat );
	DS1302_RST_LOW;
	DS1302_SCLK_HIGH;
}

/***********************************************************
* ƣDS1302_ReadByteFromAddr
* ܣDS1302ַָһByte
*           ڲ:addr   ڲdat
***********************************************************/

uchar DS1302_ReadByteFromAddr( uchar addr )
{
	uchar dat; 

	DS1302_RST_LOW;
	DS1302_SCLK_LOW;
	DS1302_RST_HIGH;
	DS1302_WriteByte(addr);	
	dat=DS1302_ReadByte();
	DS1302_RST_LOW;
	DS1302_SCLK_HIGH;
	return dat;
}

///***********************************************************
//* ƣstr_cmpx
//* ܣȽַָȵǷ
//*           ڲ:*s1, *s2, len   ڲ0/1
//*			:s1,s2ҪȽϵַ;len,Ƚϳ
//*           ֵ:1,;0,
//***********************************************************/
//
//extern uchar str_cmpx(uchar *s1,uchar *s2,uchar len)
//{
//	uchar i;
//	for(i=0;i<len;i++)if((*s1++)!=*s2++)return 0;
//	return 1;	   
//}
//
///***********************************************************
//* ƣAuto_Time_Set
//* ܣDS1302ԶʱΪʱ
//*           ڲ:   ڲ
//***********************************************************/
//
//extern const uchar *COMPILED_DATE;//ñ
//extern const uchar *COMPILED_TIME;//ñʱ
//const uchar Month_Tab[12][3]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"}; 
//
//extern void Auto_Time_Set( void )
//{
//	uchar temp[3];
//	uchar i;
//
//	for( i=0; i<3; i++ )temp[i]= COMPILED_DATE[i];
//	for(i=0;i<12;i++)if(str_cmpx((uchar*)Month_Tab[i],temp,3))break;	
//	CurrentTime.Month=i+1;//õ·
//	if(COMPILED_DATE[4]==' ')CurrentTime.Date=COMPILED_DATE[5]-'0'; 
//	else CurrentTime.Date=10*(COMPILED_DATE[4]-'0')+COMPILED_DATE[5]-'0';  
//	CurrentTime.Year=/*1000*(COMPILED_DATE[7]-'0')+100*(COMPILED_DATE[8]-'0')*/+10*(COMPILED_DATE[9]-'0')+COMPILED_DATE[10]-'0';	   
//	CurrentTime.Hour=10*(COMPILED_TIME[0]-'0')+COMPILED_TIME[1]-'0';  
//	CurrentTime.Minute=10*(COMPILED_TIME[3]-'0')+COMPILED_TIME[4]-'0';  
//	CurrentTime.Second=10*(COMPILED_TIME[6]-'0')+COMPILED_TIME[7]-'0';  
//}

/***********************************************************
* ƣDS1302_Init
* ܣDS1302ʼ
*           ڲ:   ڲ
***********************************************************/

void DS1302_Init( void )
{
	if ( DS1302_ReadByteFromAddr(DS1302_RAM1_READ) != INIT_FLAG ) // жǷʼ
	{
	    DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, WP_STOP );// ȡд
		DS1302_WriteByteToAddr( DS1302_YEAR_WRITE,    CurrentTime.Year );       // 
		DS1302_WriteByteToAddr( DS1302_DAY_WRITE,     CurrentTime.Week );       // 
		DS1302_WriteByteToAddr( DS1302_MONTH_WRITE,   CurrentTime.Month );      // 
		DS1302_WriteByteToAddr( DS1302_DATE_WRITE,    CurrentTime.Date );       // 
		DS1302_WriteByteToAddr( DS1302_HOUR_WRITE,    CurrentTime.Hour&MODE_24 );  // ʱ 24Сʱ
		DS1302_WriteByteToAddr( DS1302_MINUTE_WRITE,  CurrentTime.Minute );     // 
		DS1302_WriteByteToAddr( DS1302_SECOND_WRITE,  CurrentTime.Second&0x7f );//  DS1302
		DS1302_WriteByteToAddr( DS1302_TRICKLECHARGER_WRITE, 0xa5 );//  	
		DS1302_WriteByteToAddr( DS1302_RAM1_WRITE, INIT_FLAG);    // дʼ־
		DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, WP_START );// д
	}
}

/***********************************************************
* ƣDS1302_ReadTime
* ܣDS1302ȡʱ䱣ʱṹ
*           ڲ:   ڲ
***********************************************************/

void DS1302_ReadTime(void )
{
	CurrentTime.Second = DS1302_ReadByteFromAddr(DS1302_SECOND_READ);
	CurrentTime.Minute = DS1302_ReadByteFromAddr(DS1302_MINUTE_READ);
	CurrentTime.Hour   = DS1302_ReadByteFromAddr(DS1302_HOUR_READ);
	CurrentTime.Date   = DS1302_ReadByteFromAddr(DS1302_DATE_READ);
	CurrentTime.Month  = DS1302_ReadByteFromAddr(DS1302_MONTH_READ);
	CurrentTime.Week   = DS1302_ReadByteFromAddr(DS1302_DAY_READ );
	CurrentTime.Year   = DS1302_ReadByteFromAddr(DS1302_YEAR_READ);
}

///***********************************************************
//* ƣDS1302_JudgeAddr
//* ܣDS1302жϵַ,ڴʱ伫ֵ
//*           ڲ:addr   ڲvalue
//***********************************************************/
//
//static uchar DS1302_JudgeAddr( uchar addr )
//{
//	static uchar value;
//
//	switch ( addr )
//	{
//		case 0x80: value=59;break;	 // 
//		case 0x82: value=59;break;	 // 
//		case 0x84: value=23;break;	 // ʱ
//		case 0x86: 	 // 
//		{
//			if( CurrentTime.Month == 0x02 )
//			{
//				if ( CurrentTime.Year /4==0 ) value = 29;
//				else value = 28;
//			}
//			if( CurrentTime.Month == 0x01 ||CurrentTime.Month == 0x03||CurrentTime.Month == 0x05||
//			    CurrentTime.Month == 0x07 ||CurrentTime.Month == 0x08||CurrentTime.Month == 0x10||
//				CurrentTime.Month == 0x012 ) value = 31;
//			if( CurrentTime.Month == 0x04 ||CurrentTime.Month == 0x06||CurrentTime.Month == 0x09||
//				CurrentTime.Month == 0x011 ) value = 30;
//		}break;									
//		case 0x88: value=12;break;	 // 
//		case 0x8A: value=7;break;	 // 
//		case 0x8C: value=99;break;	 // 
//		default: break;
//	}
//	return value;
//}

///***********************************************************
//* ƣDS1302_AddTime
//* ܣDS1302ʱ
//*           ڲ:addr,dat   ڲ
//***********************************************************/
//
//void DS1302_AddTime( uchar addr, uchar dat )
//{ 
//   uchar Max;
//   	
//   Max=DS1302_JudgeAddr( addr );    // жʱֵ
//   dat = dat /16*10 +dat%16;
//   if ( addr ==0x86 || addr==0x88 ) // жǷΪա
//   {
//   		if ( ++dat > Max ) dat=1;
//   }
//   else { if ( ++ dat>Max)dat=0 ; }
//   dat = dat /10*16 +dat%10;
//   DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, 0x00 );// ȡд
//   DS1302_WriteByteToAddr( addr, dat); // ڵʱ
//   DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, 0x00 );// ȡд			
//}
//
///***********************************************************
//* ƣDS1302_CutTime
//* ܣDS1302ʱ
//*           ڲ:addr,dat   ڲ
//***********************************************************/
//
//void DS1302_CutTime( uchar addr, uchar dat )
//{ 
//   uchar Max;
//   	
//   Max=DS1302_JudgeAddr( addr );    // жʱֵ
//   dat = dat /16*10 +dat%16;
//   if ( addr==0x86 || addr==0x88 ) 	// жǷΪա
//   {
//   		if ( --dat <1 ) dat=Max;
//   }
//   else{if ( --dat>Max)dat=Max ;}
//   dat = dat /10*16 +dat%10;
//   DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, 0x00 );// ȡд
//   DS1302_WriteByteToAddr( addr, dat); // ڵʱ
//   DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, 0x00 );// ȡд			
//}




