/*****************************
* @File Name: DS1302.H
* @Author	: JZHG
* @Time     : 2012-11-05
* @Version  : V1.0
******************************/

#ifndef _DS1302_H_
#define _DS1302_H_
#include "SYS.h"

/************************************
*		 DS1302˿ڶ
*************************************/

sbit ds1302_sclk = P2^3; // DS1302ʱ
sbit ds1302_io   = P2^4; // DS1302
sbit ds1302_rst  = P2^5; // DS1302Ƭѡ

/************************************
*		 DS1302
*************************************/

#define INIT_FLAG  0x10   // ʼ־ 
#define WP_STOP    0x00	  // ֹͣд
#define WP_START   0x80	  // д
#define MODE_24    0x7f   // 24Сʱ
#define MODE_12    0x8f	  // 12Сʱ
#define DS1302_SCLK_HIGH (ds1302_sclk=1) // ʱ
#define DS1302_SCLK_LOW  (ds1302_sclk=0) // ʱ
#define DS1302_RST_HIGH  (ds1302_rst =1) // Ƭѡ
#define DS1302_RST_LOW   (ds1302_rst =0) // Ƭѡ
#define DS1302_IO_HIGH   (ds1302_io  =1) // 
#define DS1302_IO_LOW    (ds1302_io  =0) // 
#define DS1302_IO_READ   (ds1302_io    ) // ߶

/************************************
*		 DS1302ַ/ָд
*          CLOCKģʽ
*************************************/

#define DS1302_SECOND_WRITE 0x80  // 
#define DS1302_MINUTE_WRITE 0x82  // 
#define DS1302_HOUR_WRITE   0x84  // ʱ
#define DS1302_DATE_WRITE   0x86  // 
#define DS1302_MONTH_WRITE  0x88  // 
#define DS1302_DAY_WRITE    0x8A  // 
#define DS1302_YEAR_WRITE   0x8C  // 

#define DS1302_CONTROL_WRITE           0x8E	 // WP
#define DS1302_TRICKLECHARGER_WRITE    0x90	 // ϸ
#define DS1302_CLOCKBURST_WRITE        0xBE	 // ʱ⧷

/************************************
*		 DS1302ַ/ָ
*          CLOCKģʽ
*************************************/
#define DS1302_SECOND_READ 0x81
#define DS1302_MINUTE_READ 0x83
#define DS1302_HOUR_READ   0x85
#define DS1302_DATE_READ   0x87
#define DS1302_MONTH_READ  0x89
#define DS1302_DAY_READ    0x8B
#define DS1302_YEAR_READ   0x8D

#define DS1302_CONTROL_READ           0x8F
#define DS1302_TRICKLECHARGER_READ    0x91
#define DS1302_CLOCKBURST_READ        0xBF

/************************************
*		 DS1302ַ/ָ
*RAMģʽ( һֽڱǷʼ־)
*************************************/
#define DS1302_RAM1_WRITE 0xC0
#define DS1302_RAM1_READ  0xC1

/************************************
* 	ʱݵĽṹ
*************************************/
typedef struct 
{
	uchar Second;  // 
	uchar Minute;  // 
	uchar Hour  ;  // ʱ
	uchar Date  ;  // 
	uchar Month ;  // 
	uchar Week  ;  // 
	uchar Year  ;  // 
}TIME_TYPE;

/************************************
* 	DS1302APIӿں			  
*************************************/

extern TIME_TYPE CurrentTime;
extern void DS1302_WriteByteToAddr( uchar addr, uchar dat ); // DS1302ַָдһByte
extern uchar DS1302_ReadByteFromAddr( uchar addr ); // 	DS1302ַָһByte
extern void DS1302_Init( void );   // DS1302ʼ
extern void DS1302_ReadTime(void );// DS1302ȡʱ䱣ʱṹ
//extern void DS1302_AddTime( uchar addr, uchar dat ); // DS1302ʱ
//extern void DS1302_CutTime( uchar addr, uchar dat ); // DS1302ʱ

///////////////////////////////
#endif
