/*****************************
* @File Name: LCD12864.C
* @Author	: JZHG
* @Time     : 2012-11-05
* @Version  : V1.0
******************************/

#include "LCD12864.h"
#include "intrins.h"


/***********************************************************
* ƣLCD12864_Check_Busy
* ܣLCDæµ
*           ڲ:      ڲ0-1
***********************************************************/

uchar LCD12864_Check_Busy( void )
{
	uchar flag;
	LCD12864_PORT |= 0xff;
	LCD12864_RS = 0;
	LCD12864_RW = 1;
    LCD12864_E=1;
	flag=LCD12864_BF;
	LCD12864_E=0;
	if ( flag==0 ) return 0;
	return 1;
}

/***********************************************************
* ƣLCD12864_Write_Data
* ܣLCDдݺ
*           ڲ:modedat     ڲ
*           mode0-дָ 1-д
***********************************************************/

void LCD12864_Write_Data( uchar mode, uchar dat )
{
	while( LCD12864_Check_Busy() );	// æµ
	LCD12864_RS = mode;
	LCD12864_RW = 0;
	LCD12864_PORT = dat;
	LCD12864_E = 1;
	Delay_n10us( 1 );
	LCD12864_E = 0;		
}

/***********************************************************
* ƣLCD12864_Init
* ܣLCDʼ
*           ڲ:     ڲ
***********************************************************/

void LCD12864_Init( void )
{
	LCD12864_PSB=1;
	LCD12864_RST = 0;
	LCD12864_PORT=0;	   // ݳʼ
	Delay_nms(15);
	LCD12864_RST = 1;
	LCD12864_Write_Data( LCD12864_COM,0x30); // ùΪһ
	Delay_nms(5);
	LCD12864_Write_Data( LCD12864_COM,0x30); // ùΪһ
	LCD12864_Write_Data( LCD12864_COM,0x08); // رʾ
	LCD12864_Write_Data( LCD12864_COM,0x06); // 
	LCD12864_Write_Data( LCD12864_COM,0x0c); // ʾ
	LCD12864_Write_Data( LCD12864_COM,0x01); // 
}

/***********************************************************
* ƣLCD12864_Clear
* ܣ
*           ڲ:     ڲ
***********************************************************/

 void LCD12864_Clear(void) 
 { 
    LCD12864_Write_Data( LCD12864_COM,0x01); 
    Delay_nms(5);
 }

/***********************************************************
* ƣLCD12864_Clear_GDRAM
* ܣָ
*           ڲ:     ڲ
***********************************************************/

void LCD12864_Clear_GDRAM( void )   
{
	uchar i,j,k;
	LCD12864_Write_Data( LCD12864_COM,0x34); // Ϊָ
	LCD12864_Write_Data( LCD12864_COM,0x36); // 򿪻ͼ
	for(k=0;k<2;k++) // 
	{
		for(i=0;i<32;i++) 
		{
			LCD12864_Write_Data( LCD12864_COM,0x80+i);// дY
			if(k==0)
			{
		    	LCD12864_Write_Data( LCD12864_COM,0x80);// дX
			}
			else
			{
				LCD12864_Write_Data( LCD12864_COM,0x88);// дX
			}
			for(j=0;j<16;j++) // дֽ
			{
				LCD12864_Write_Data( LCD12864_DAT,0x00);// 
			}
		}
	}
	LCD12864_Write_Data( LCD12864_COM,0x30);
}
/***********************************************************
* ƣLCD12864_SetXY
* ܣLCD꺯
*           ڲ: x,y      ڲ
*           y: 0-3	  x: 0-7
***********************************************************/

void LCD12864_SetXY(u8 x,u8 y)
{
   	x=x&0x07;
	switch(y)
	{
		case 0:LCD12864_Write_Data( LCD12864_COM,0x80+x);break;
		case 1:LCD12864_Write_Data( LCD12864_COM,0x90+x);break;
		case 2:LCD12864_Write_Data( LCD12864_COM,0x88+x);break;
		case 3:LCD12864_Write_Data( LCD12864_COM,0x98+x);break;
		default: break;
	}
}
/***********************************************************
* ƣLCD12864_Show_hz
* ܣʾֺ
*           ڲ:x, y, *p     ڲ
*           x: 0-7	  y: 0-3
***********************************************************/

void LCD12864_Show_hz(uchar x,uchar y,uchar code *p)	
{
	LCD12864_SetXY(x,y);         // LCD꺯
	while(*p>0)
	{
		LCD12864_Write_Data( LCD12864_DAT,*p);
		p++;
	}
}
/***********************************************************
* ƣLCD12864_ShowNum
* ܣLCDʾһλֺ
*           ڲ: x,y,num      ڲ
*           y: 0-3	  x: 0-7	num: 0-9
***********************************************************/

void LCD12864_ShowNum( u8 x, u8 y,  u8 num )
{
     u8 code NUM[]={"0123456789    +-*/%="}; 
	 LCD12864_SetXY(x,y);         // LCD꺯
	 LCD12864_Write_Data( LCD12864_DAT,NUM[num]);	  // д
}

/***********************************************************
* ƣLCD12864_ShowNum
* ܣLCDʾһֺ
*           ڲ: x,y,num,dat      ڲ
*           y: 0-3	  x: 0-7	num:  dat: 
***********************************************************/

void LCD12864_ShowNumS( u8 x, u8 y, u8 num, u8 dat[] )
{
   u8 i;
   LCD12864_SetXY(x,y);         // LCD꺯
   for ( i=0; i<num; i++ )
   {	
   		LCD12864_Write_Data( LCD12864_DAT, dat[i]+48 );    // LCDдݺ
   }
}
///***********************************************************
//* ƣLCD12864_Draw
//* ܣLCDͼ
//*           ڲ:stx, sty, enx, eny, *p   ڲ
//***********************************************************/
//
//void LCD12864_Draw(uchar stx,uchar sty,uchar enx,uchar eny,uchar code *p)
//{			   //ʼX      ʼY      յX     յY     //ָ
//
//	uchar x,y,zjs,hs;// X Y  ֽ  
//	zjs=enx/8;	   //ֽ
//	hs=32-(sty-0x80); //
//
//	LCD12864_Write_Data( LCD12864_COM,0x34); //Ϊָ
//	LCD12864_Write_Data( LCD12864_COM,0x36); //򿪻ͼ
//
//	for(y=0;y<hs;y++)  //ϰ
//	{
//	 	LCD12864_Write_Data( LCD12864_COM,sty+y);  //Yַ
//		LCD12864_Write_Data( LCD12864_COM,stx);	   //Xַ
//		for(x=0;x<zjs;x++) 
//		{
//			LCD12864_Write_Data( LCD12864_DAT,*p++); //д
//		}
//	}
//	if((sty-0x80)+eny>32) //жǷʾ°
//	{
//		for(y=0;y<eny-hs;y++) //°
//		{
//			LCD12864_Write_Data( LCD12864_COM,0x80+y);//Yַ
//			LCD12864_Write_Data( LCD12864_COM,stx+8);		//Xַ
//			for(x=0;x<zjs;x++)
//			{
//				LCD12864_Write_Data( LCD12864_DAT,*p++);//д
//			}
//		}
//	}
//   LCD12864_Write_Data( LCD12864_COM,0x30);
//}

/***********************************************************
* ƣLCD12864_FB
* ܣLCDⷴ׺
*           ڲ:x, y, value, font_num   ڲ
***********************************************************/

void LCD12864_FB(u8 x, u8 y, u8 value, u8 font_num)
{ 
 u8 i,j;
 LCD12864_Write_Data( LCD12864_COM,0x32);      //ͼ
 LCD12864_Write_Data( LCD12864_COM,0x36);   //չָ
 y<<=4;        //ӵڼСʼ
 for(i=0;i<16;i++)
 {
   LCD12864_Write_Data( LCD12864_COM,0x80+y);  //   ַΪ0x800x90,0x80ʱΪһУ0x90ʱΪ
   LCD12864_Write_Data( LCD12864_COM,0x80+x);  //   xֵķΧΪ015֮ż
  for(j=0;j<font_num;j++)
   LCD12864_Write_Data( LCD12864_DAT,value);
  y++;
 }
 LCD12864_Write_Data( LCD12864_COM,0x32);
 LCD12864_Write_Data( LCD12864_COM,0x30);
}
